//------------------------------------------------------
//
//   Greg's Blocks Mod - Main
//
//------------------------------------------------------

package gcewing.blocks;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.Map;
import java.util.Hashtable;

import net.minecraft.block.*;
import net.minecraft.entity.player.*;
import net.minecraft.init.*;
import net.minecraft.item.*;
import net.minecraft.world.*;

import net.minecraftforge.common.*;
import cpw.mods.fml.common.*;
import cpw.mods.fml.common.event.*;
import cpw.mods.fml.common.network.*;
import cpw.mods.fml.common.registry.*;

@Mod(modid = Info.modID, name = Info.modName, version = Info.versionNumber,
	acceptableRemoteVersions = Info.versionBounds)

public class GregsBlocks extends BaseMod {

	//@Mod.Instance("GregsBlocks")
	public static GregsBlocks mod;

	//@SidedProxy(clientSide="gcewing.blocks.ProxyClient", serverSide="gcewing.blocks.Proxy")
	//public static Proxy proxy;
	
	public static String modName = "GregsBlocks";
	public final static String textureDir = "/gcewing/blocks/resources/";
	public final static String textureFile = textureDir + "textures.png";
	
	static String configName = modName + ".cfg";
	static File cfgfile;
	
	static Channel channel = new Channel();
	
	//
	//   Blocks and Items
	//
	
	public static BlockSawbench blockSawbench;
	public static Block blockShape;

	public static Item itemSawblade;
	public static Item itemLargePulley;
	public static Item itemChisel;
	
	public GregsBlocks() {
		super();
		mod = this;
	}
	
	@Mod.EventHandler
	public void preInit(FMLPreInitializationEvent e) {
		super.preInit(e);
	}

	@Mod.EventHandler
	public void init(FMLInitializationEvent e) {
		super.init(e);
	}
	
	@Mod.EventHandler
	public void postInit(FMLPostInitializationEvent e) {
		super.postInit(e);
	}

	@Override
	BaseModClient initClient() {
		return new GregsBlocksClient(this);
	}

	void registerBlocks() {
		blockSawbench = newBlock("sawbench", BlockSawbench.class);
		blockSawbench.setHardness(2.0F);
		blockShape = newBlock("shape", BlockShape.class, ItemShape.class);
	}
	
	void registerTileEntities() {
		GameRegistry.registerTileEntity(TESawbench.class, "gcewing.sawbench");
		GameRegistry.registerTileEntity(TEShape.class, "gcewing.shape");
	}
	
	void registerItems() {
		itemSawblade = newItem("sawblade");
		itemLargePulley = newItem("largePulley");
		itemChisel = newItem("chisel", ItemChisel.class);
	}

	void registerRecipes() {
		newRecipe(blockSawbench, 1, "IsI", "WWP", "WWp",
			'I', Items.iron_ingot, 's', itemSawblade, 'W', Blocks.planks, 'p', Blocks.wooden_pressure_plate,
			'P', itemLargePulley);
		newRecipe(itemSawblade, 1, " I ", "IsI", " I ",
			'I', Items.iron_ingot, 's', Items.stick);
		newRecipe(itemLargePulley, 1, " W ", "WsW", " W ",
			'W', Blocks.planks, 's', Items.stick);
		newRecipe(itemChisel, 1, "I", "s",
			'I', Items.iron_ingot, 's', Items.stick);
}
	
	//--------------- GUIs ----------------------------------------------------------

	public final static int guiSawbench = 1;
	
	@Override
	void registerContainers() {
		addContainer(guiSawbench, ContainerSawbench.class);
	}
	
	public void openGuiSawbench(World world, int x, int y, int z, EntityPlayer player) {
		openGui(player, guiSawbench, world, x, y, z);
	}

}
